	PROGRAM QTAB_ALIAS
C *** LAST REVISED ON 28-JUL-1992 16:11:26.14
C *** SOURCE FILE: [LONGD.GH]ALIAS5.FOR
C
C	PROGRAM TO PLOT SIGMA-0 VS WIND ALIAS CURVES
C
C	WIND ERROR SQUARED IS USED
C
	CHARACTER*80 NFILE,CLINE
	DIMENSION BANG(8),IBPOL(8),AINC(8),X(36001),Y(36001,8)
	DIMENSION WERR(36001),WERRD(36001),SWER(20),SW(20)
	DIMENSION SIG(8)
	COMMON /BUFFSIZE/NPTS
	DATA ANGINC/1./,THRES2/.05/,THRES3/.07/
C
	LOGICAL YESNO1
C
        DATA NFILE/'/auto/archive/geomodel/linux/QS_MODL0001'/
C
C  READ G/H TABLE FILE
C
	PRINT 11,NFILE
11	FORMAT(' QS Geophysical Model Function Test Program'//
     $   ' Default Model Function File:',A,/' Enter New File: ',$)
	READ(*,90) CLINE
90	FORMAT(A80)
	IF (CLINE.NE.' ') NFILE=CLINE
C
C  READ TABULAR GEOPHYSICAL MODEL FUNCTION FILE
C
	CALL MFTABLEQ (NFILE)
	print *,'model function table read completed'
C
	IFLAG=1
	PRINT 251
251	FORMAT(' Plot SOS Error, etc.? ',$)
	ISOS=1
	IF (.not.YESNO1(.TRUE.)) ISOS=0
	ICNT=-1
C
C	SET SOME DEFAULT PARAMETERS
C
	WIND=10.0
	WDIR=0.0
	NBEAMS=2
	DO I=1,8
		BANG(I)=(I-1)*90.0+45.0
		IBPOL(I)=2
		AINC(I)=46.0
	END DO
C
9000	PRINT 1
  1	FORMAT(' Enter Input Wind Speed: (deg) (0 to end) ',$)
	WIND=READVAL1(WIND,IEND)
	IF (WIND.LE.0.0.OR.IEND.LT.0) GOTO 9999
	PRINT 102
 102	FORMAT(' Enter Input Wind Direction: (m/s) ',$)
	WDIR=READVAL1(WDIR,IEND)
	IF (IEND.LT.0) GOTO 9999
C
	THRES2a=THRES2*WIND
	ICNT=ICNT+1
C
C	IF (IFLAG.EQ.1) THEN
		PRINT 2
  2		FORMAT(' Enter Number of Beams: ',$)
		NBEAMS=IREADVAL1(NBEAMS,IEND)
		IF (IEND.LT.0.OR.NBEAMS.LE.0) GOTO 9999
		PRINT *,'Polarization: H=2 V=1'
		DO I=1,NBEAMS
			PRINT 3,I,NBEAMS
  3			FORMAT(/' For Beam',I2,' of',I2,
     $                          ' Enter Azimuth Angle: ',$)
			BANG(I)=READVAL1(BANG(I),IEND)
c			PRINT 103,I,NBEAMS
c 103			FORMAT(' For Beam',I2,' of',I2,
c     $				' Enter Polarization: ',$)
c			IBPOL(I)=IREADVAL1(IBPOL(I),IEND)
c			IF (IEND.LT.0.OR.IBPOL(I).LT.1) GOTO 9999
			PRINT 203,I,NBEAMS
 203			FORMAT(' For Beam',I2,' of',I2,
     $                         ' Enter Incidence Angle: ',$)
			AINC(I)=READVAL1(AINC(I),IEND)
			if (ainc(i).gt.50.0) then
			   ibpol(i)=1
			else
			   ibpol(i)=2
			endif
			IF (IEND.LT.0) GOTO 9999
			CALL MODEL_FUNCTIONQ(BANG(I),AINC(I),IBPOL(I),
     $				WIND,WDIR,SIGMA0)
		PRINT *,'   Corresponding Sigma-0:',SIGMA0,DB(SIGMA0),' DB'
		END DO
C	ENDIF
C
	call rterm(-2)  ! clear screen
c
	IACNT=0
	NPTS=(360./ANGINC)+1
	ANGCON=360./FLOAT(NPTS-1)
	WMAX=0.
	WMIN=25.
	DO 85 IBEAM=1,NBEAMS
		IPOL=IBPOL(IBEAM)
		CALL MODEL_FUNCTIONQ(BANG(IBEAM),AINC(IBEAM),IPOL,
     $			WIND,WDIR,SIGMA0)
		SIG(IBEAM)=SIGMA0
85	CONTINUE
	DO 100 IBEAM=1,NBEAMS
		IPOL=IBPOL(IBEAM)
		DO 50 IANG=1,NPTS+1
			ANG=FLOAT(IANG-1)*ANGCON
			X(IANG)=ANG
			CALL IMODEL_FUNCTIONQ(BANG(IBEAM),AINC(IBEAM),IPOL,
     $				WSPEED,ANG,SIG(IBEAM))
			Y(IANG,IBEAM)=WSPEED
			WMAX=AMAX1(WMAX,WSPEED)
			WMIN=AMIN1(WMIN,WSPEED)
50		CONTINUE
100	CONTINUE
	YMIN=WMIN					!MIN WIND SPEED
	YMAX=WMAX					!MAX WIND SPEED
	XLEN=6.
	YLEN=4.
	XORG=1.5
	YORG=1.
	NSKIP=10./ANGINC
	NPTSP=NPTS
	DX=360./XLEN
	DY=(YMAX-YMIN)/YLEN
C
	IF (IFLAG.EQ.1) THEN
		CALL CTERM(0)				!CLEAR TERMINAL SCREEN
		CALL FRAME(3,0,0.,0.,1.)		!INTIALIZE PLOT PACKAGE
		CALL PLOT(XORG,YORG,-3) 		!NEW ORIGIN
		CALL PFACTOR(0.45)
	ELSE
C		CALL CTERM(-2)
		CALL CTERM(-1)
		IF (ICNT.EQ.4) THEN
			ICNT=0
			CALL NEWPAGE
		ENDIF
		XOFF=MOD(ICNT,2)*(XLEN+1.2)
		YOFF=(ICNT/2)*(YLEN+2.20)
		CALL PPLOT(XOFF,YOFF,-3)
	ENDIF
41	CALL AXIS3(0.,0.,'Wind Direction (deg)',-20,XLEN,0.,0.,360.,
     $		7.01,-0.12,1003.0)
	CALL AXIS3(0.,0.,'Wind Speed (m/s)',1016,YLEN,90.,YMIN,DY*YLEN+YMIN,
     $		5.,-0.12,5.02)
	XV=0.
	CS=.15
	YV=YLEN+.1+(CS+.05)*NBEAMS
	CALL SYMBOL(XV-CS*2.,YV+.25,CS,'Input Wind Speed=',0.,17,-1)
	CALL NUMBER(999.,999.,CS,WIND,0.,6.02,-1)
	CALL SYMBOL(999.,999.,CS,' m/s  Azimuth=',0.,14,-1)
	CALL NUMBER(999.,999.,CS,WDIR,0.,7.02,-1)
	CALL SYMBOL(999.,999.,CS,' deg',0.,4,-1)
	YP=(WIND-YMIN)/DY
	CALL PLOT(-.1,YP+.1,3)			! MARK AT CORRECT WIND
	CALL PLOT(0.,YP,2)
	CALL PLOT(-.15,YP,2)
	CALL PLOT(0.,YP,2)
	CALL PLOT(-.1,YP-.1,2)
	XP=WDIR/DX
	CALL PLOT(XP-.1,-.1,3)			! MARK AT CORRECT ANGLE
	CALL PLOT(XP,0.,2)
	CALL PLOT(XP,-.15,2)
	CALL PLOT(XP,0.,2)
	CALL PLOT(XP+.1,-.1,2)
c
c	write to file
c
c	do i=1,nptsp
c		write (1,8000) x(i),(tab,y(i,j),j=1,nbeams)
c8000		format(x,f,<nbeams>(a1,f))
c	end do
c	close(1)
C
C	PLOT CURVES
C
c        call cterm(1)
c        print *,'beams',nbeams
c        call cterm(-1)
	DO 125 IBEAM=1,NBEAMS
		ISYM=IBEAM+3
c        call cterm(1)
c                print *,' *** !before line',ibeam,isym
c        call cterm(-1)
		CALL LINE(X,Y(1,IBEAM),NPTSP,1,NSKIP,ISYM,1,1,0.,DX,YMIN,DY)
c        call cterm(1)
c        print *,' '
c        call cterm(-1)
		CALL SYMBOL(XV+CS/2.,YV+CS/2.,CS,char(ISYM),0.,1,1)
		CALL SYMBOL(XV+CS,YV,CS,' Beam ',0.,6,-1)
		CALL NUMBER(999.,999.,CS,FLOAT(IBEAM),0.,1001.,-1)
		IPOL=IBPOL(IBEAM)
		IF (IPOL.EQ.2) THEN
			CALL SYMBOL(999.,999.,CS,' H pol Ang=',0.,11,-1)
		ELSE
			CALL SYMBOL(999.,999.,CS,' V pol Ang=',0.,11,-1)
		ENDIF
		CALL NUMBER(999.,999.,CS,BANG(IBEAM),0.,5.01,-1)
		CALL SYMBOL(999.,999.,CS,' Inc=',0.,5,-1)
		CALL NUMBER(999.,999.,CS,AINC(IBEAM),0.,5.01,-1)
		CALL SYMBOL(999.,999.,CS,' S=',0.,3,-1)
		CALL NUMBER(999.,999.,CS,DB(SIG(IBEAM)),0.,6.02,-1)
		CALL SYMBOL(999.,999.,CS,' dB',0.,3,-1)
		YV=YV-CS-.05
125	CONTINUE
C
C	IF (ISOS.NE.0) THEN
C		IFLAG=0
C		CALL PPLOT(-XOFF,-YOFF,-3)
C		CALL CTERM(2)
C		CALL NEWPAGE
C		GOTO 9000
C	ENDIF
C
C	DETERMINE INTERSECTIONS
C
43	WERRMIN=1000.
	WERRMAX=0.
	DO 200 IANG=1,NPTS+1
		ERR=0.
		DO 150 IBEAM=1,NBEAMS-1
			DO 150 I=IBEAM+1,NBEAMS
				ERR=ERR+ABS(Y(IANG,IBEAM)-Y(IANG,I))**2
150		CONTINUE
		WERRMAX=AMAX1(WERRMAX,ERR)
		WERRMIN=AMIN1(WERRMIN,ERR)
		WERR(IANG)=ERR
200	CONTINUE
	DYW=(WERRMAX-WERRMIN)/YLEN
	IF (ISOS.EQ.1) THEN
	 CALL AXIS(XLEN,0.,'Objective Function Value ',-24,YLEN,90.,WERRMIN,DYW)
	 CALL DASHL(X,WERR,NPTSP,1,0,0,1,1,0.,DX,WERRMIN,DYW)
	 call plot(0.,0.,5)
	 CALL CTERM(1)
	ELSE
 	 CALL PLOT(0.,0.,5)
	 CALL CTERM(1)
	ENDIF
	PLEN=0.3
	print *
C
C	COMPUTE ERROR DIREVATIVE
C
	WERRD(1)=(WERR(1)-WERR(NPTS))
	WDMIN=WERRD(1)
	WDMAX=WERRD(1)
CC	PRINT *,1,WERR(1),WERRD(1)
	DO 300 IANG=2,NPTS+1
		WERRD(IANG)=(WERR(IANG)-WERR(IANG-1))
CC		PRINT *,IANG,WERR(IANG),WERRD(IANG)
		WDMIN=AMIN1(WDMIN,WERRD(IANG))
		WDMAX=AMAX1(WDMAX,WERRD(IANG))
300	CONTINUE
	WDMAX=AMAX1(WDMAX,ABS(WDMIN))
	WDMIN=-WDMAX
	DYWD=(WDMAX-WDMIN)/YLEN
	YP=(0.-WDMIN)/DYWD
	XP=XLEN+.8
	IF (.FALSE..AND.ISOS.EQ.1) THEN
		CALL CTERM(-1)
		CALL PLOT(XP+.1,YP,3)
		CALL PLOT(XP-.1,YP,2)
		CALL AXIS(XP,0.,'Derivative of Obj Funct  ',-26,
     $			YLEN,90.,WDMIN,DYWD)
		CALL LINE(X,WERRD,NPTSP,1,0,0,1,1,0.,DX,WDMIN,DYWD)
		CALL PLOT(0.,0.,5)
		CALL CTERM(1)
	ENDIF
C
C	FIND ALIAS LOCATIONS
C
	NEND=20
	DO 400 IANG=1,NPTS
C		IF (ABS(WERR(IANG)).GT.THRES2a) GOTO 400 ! SKIP WAY OFF
		IF (SIGN(1.,WERRD(IR(IANG-1))).EQ.
     $			SIGN(1.,WERRD(IR(IANG)))) GOTO 400! SKIP SAME SIGN DERIV.
		ANGI=ANGINC
		XHOLD=X(IR(IANG-1))
C		PRINT *,'BEGIN FINE SEARCH ',X(IANG),WERR(IANG)
C     $			,X(IR(IANG-1)),WERR(IR(IANG-1))
C
		DO 808 ILOOK=1,3		! NUMBER OF SMALLER INCREMENTS
C		PRINT *,'OUTER LOOP ',ILOOK,XHOLD,ILOC
		ANGCON2=ANGI/FLOAT(NEND/2)
		ANGMIN=XHOLD-ANGI
		EMIN2=1000.
		DO 410 IANG2=1,NEND
			AANG=FLOAT(IANG2-1)*ANGCON2+ANGMIN
			DO 420 IBEAM=1,NBEAMS
				IPOL=IBPOL(IBEAM)
C				CALL WVLINR(2.,35,AINC(IBEAM),KT1,KT2,AT1,AT2)
C				CALL WVPHIR(AANG,BANG(IBEAM),PHIR)
C				CALL WVGXHX(PHIR,IPOL,KT1,KT2,AT1,AT2,G1,H1)
C				WSPEED=10.**((SIG(IBEAM)/10.-G1)/H1)
			CALL IMODEL_FUNCTIONQ(BANG(IBEAM),AINC(IBEAM),IPOL,
     $					WSPEED,AANG,SIG(IBEAM))
				SW(IBEAM)=WSPEED
420			CONTINUE
			EMIN=0.
			DO 430 IB1=1,NBEAMS-1
				DO 430 IB2=IB1+1,NBEAMS
					EMIN=EMIN+ABS(SW(IB1)-SW(IB2))**2
430			CONTINUE
			IF (EMIN.LT.EMIN2) THEN
				EMIN2=EMIN
				ILOC=IANG2
			ENDIF
			SWER(IANG2)=EMIN
			IF (SWER(IANG2).EQ.0.0) GOTO 350
C			PRINT *,'SWER(',IANG2,')=',EMIN
410		CONTINUE
		IF (ILOC.EQ.1.OR.ILOC.EQ.NEND) THEN
C			PRINT *,'    > LOST AT EDGE'
			GOTO 400
		ENDIF
		IF (ABS(EMIN2).LT.THRES3) GOTO 350
		AANG=FLOAT(ILOC-1)*ANGCON2+ANGMIN
		I=ILOC
		ANGI=ANGCON2
		XHOLD=AANG
808		CONTINUE
809		PRINT *,'    > FINE SEARCH ',XHOLD,EMIN2,WERR(IANG)
		PRINT *,'      ** NO ALIAS FOUND **'
		GOTO 400
C
350		CONTINUE			! FOUND AN ALIAS
		IF (AANG.EQ.360.0) AANG=0.0
		XPP=AANG/DX
		YPP=(Y(IANG,1)-YMIN)/DY
		IF (IACNT.GT.0) THEN
			IF (ABS(AANG-ALAST).LT.ANGINC) THEN
	PRINT *,'    > THIS ALIAS TOO CLOSE TO LAST ALIAS'
				GOTO 400
			ENDIF
		ENDIF
		IACNT=IACNT+1
		ALAST=AANG
		PRINT *,'ALIAS ',IACNT,' FOUND AT ANGLE=',AANG,EMIN2
CC		PRINT *,X(IANG),X(IR(IANG-1)),Y(IANG,1),Y(IANG,2)
		CALL CTERM(-1)
		CALL PLOT(XPP-PLEN,YPP,3)
		CALL PLOT(XPP+PLEN,YPP,2)
		CALL PLOT(XPP,YPP+PLEN,3)
		CALL PLOT(XPP,YPP-PLEN,2)
		CALL PLOT(0.,0.,5)
		CALL CTERM(1)
C
400		CONTINUE		! CHECK NEXT ANGLE
	PRINT *,'TOTAL ALIASES FOUND:',IACNT
	YV=YLEN+.1+(CS+.05)*(NBEAMS+2)
	XV=0.0 ! XLEN-CS*4
	CALL CTERM(-1)
	CALL SYMBOL(XV,YV+CS,CS,'Aliases= ',0.,8,-1)
	CALL NUMBER(999.,999.,CS,FLOAT(IACNT),0.,1002.,-1)
	CALL PLOT(0.,0.,5)
	CALL PPLOT(-XOFF,-YOFF,-3)
	call cterm(1)
CC	CALL NEWPAGE
	CALL CTERM(2)
	IFLAG=0
	GOTO 9000
9999	CALL PLOTND
	CALL CTERM(2)
	STOP
	END
C
	FUNCTION IR(N)			! ROTATE AROUND BUFFER
	COMMON /BUFFSIZE/NPTS
	I=N
	IF (N.LT.1) I=NPTS+I
	IF (N.GT.NPTS) I=N-NPTS
	IR=I
	RETURN
	END
C
	FUNCTION DB(X)
	IF (X.LE.0.0) THEN
		DB=-99.99
	ELSE
		DB=10.*ALOG10(X)
	ENDIF
	RETURN
	END
C
C	SUBROUTINE SYMBOL(X,Y,CS,T,A,I,J)
C	CHARACTER*(*) T
C	CALL SYMS(X,Y,CS,T,A,I,J)
C	RETURN
C	END

	subroutine swapbuffer(ib,n)
	real ib(1)
	do i=1,n
	   call swap4(ib(i))
	end do
	return
	end

	subroutine swap4(ib)
	integer*1 ib(4),t1,t2
c	byte ib(4),t1,t2
	t1=ib(1)
	t2=ib(2)
	ib(1)=ib(4)
	ib(2)=ib(3)
	ib(3)=t2
	ib(4)=t1
	return
	end
c
c
     	SUBROUTINE MFTABLEQ (nfile)
c
c	NSCAT Algorithm Module 4.2.3
c	---------------------------------------------------------------
c	Author:  R. Scott Dunbar		Created:  24 Feb 1987
c						Revised:   1 Apr 1987
c       Modified for QS model function: DGL  2 Oct 1999
c	---------------------------------------------------------------
c	Purpose:
c
c	Read model function table file into memory for use in wind 
c	  retrieval.
c
c	---------------------------------------------------------------
	character*(*) nfile
      	common /mfunc/ table(40:60,0:50,0:90)
c	---------------------------------------------------------------
c	Open model function table file:
c     	open(unit=16,name=nfile,status='old',form='unformatted') !,readonly)
c     	read (16) table
c	close (unit=16)
c
	print *,'Read GMF ',nfile
	OPEN (UNIT = 16, FILE=nfile, STATUS='old',ACCESS='direct',
     $       RECL = 389844)
	READ (16, REC=1) table
C	READ (16, REC=2) model_kpm_table
	CLOSE (UNIT = 16)
c	call swapbuffer(table,389844/4)
c
      	return
      	end
c
c
	SUBROUTINE MODEL_FUNCTIONQ (azi,tht,kpol,u,phi,nrcs)
c
c	Version for use in Wind Field Simulation -- 19 August 1987
c	Author:  R. Scott Dunbar
c       Modified for QS model function: DGL  2 Oct 1999
c	---------------------------------------------------------------
c	Purpose:
c
c	Look up and interpolate the value of the sigma-0 model function
c	  for the given values of wind direction and wind speed.
c
c	Uses multilinear interpolation among the nearest 8 model function 
c	  values in the model function table.
c
c	INPUTS:
c		azi  =  cell azimuth w.r.t. north (deg)
c		tht  =  incidence angle (deg)
c		kpol =  antenna polarization [V = 1, H = 2] (*not used for QS)
c		u    =  wind speed (m/s)
c		phi  =  wind direction (deg)
c	OUTPUT:
c		nrcs =  model sigma-0 from table
c	---------------------------------------------------------------
c	Data declarations:
c
	real nrcs		! returned value of model function
	real mfun(2,2)		! intermediate table of interpolated values
      	common /mfunc/ table(40:60,0:50,0:90)  ! model function table
     	data kt1min, kt1max /40, 59/
c	--------------------------------------------------------------
c 	Adjust the relative azimuth into the range (0.,180.) degrees
c 	  and get interpolation coefficient q:
c
	chi 	   = azi - phi
        chi        = amod(chi,360.)
	if (chi .lt. 0.)   chi = chi  + 360.
      	if (chi .gt. 180.) chi = 360. - chi
     	ichi       = int(chi/2.)
	q          = chi/2. - ichi
	q1         = 1. - q
c	---------------------------------------------------------------
c	Get interpolation coefficients w.r.t. incidence angle:
c
        htht       = tht  ! /2.		! cut tht in half
	kt1        = int(htht)		! first index
     	if (kt1 .le. kt1min) kt1 = kt1min
      	if (kt1 .ge. kt1max) kt1 = kt1max
      	kt2        = kt1 + 1		! second index
     	at2        = htht - kt1		! second coefficient
      	at1        = 1. - at2		! first coefficient
c	---------------------------------------------------------------
c	Get interpolation coefficient w.r.t. u:
c
	ju         = int(u)		! primary speed index
	p          = u - ju
	p1         = 1. - p
c	---------------------------------------------------------------
c	Interpolate with respect to incidence angle:
c
	do 40 i = 1,2
	    kchi = i + ichi - 1
	    if (kchi .gt. 90) kchi = 180 - kchi
	    do 50 j = 1,2
		ku = j + ju - 1
		if (ku .eq. 0) then
			mfun(j,i) = 0.0
		else
			mfun(j,i) =  at1*table(kt1,ku,kchi) +
     $			     at2*table(kt2,ku,kchi) !,kpol)
		endif
 50	    continue
 40	continue
c	---------------------------------------------------------------
c	Do bilinear interpolation of the working table to find nrcs(i):
c
	nrcs = p1*q1*mfun(1,1) + p*q1*mfun(2,1) + 
     *		   q*p1*mfun(1,2) +  p*q*mfun(2,2)
c
c	---------------------------------------------------------------
	return
	end
c
c
	SUBROUTINE IMODEL_FUNCTIONQ (azi,tht,kpol,u,phi,nrcs)
c
c	Author:  D. Long	25 Mar 1992
c       Modified for QS model function: DGL  2 Oct 1999
c	---------------------------------------------------------------
c	Purpose:
c
c	Look up and interpolate the value of the sigma-0 model function
c	  for the given values of wind direction and sigma-0 to determine
c	  the wind speed.
c
c	Uses multilinear interpolation among the nearest 8 model function 
c	  values in the model function table.
c
c	INPUTS:
c		azi  =  cell azimuth w.r.t. north (deg)
c		tht  =  incidence angle (deg)
c		kpol =  antenna polarization [V = 1, H = 2] (* not used for QS model)
c		phi  =  wind direction (deg)
c		nrcs =  model sigma-0 from table
c	OUTPUT:
c		u    =  wind speed (m/s)
c	---------------------------------------------------------------
c	Data declarations:
c
	real nrcs		! input value of model function
	real mfun(2)		! intermediate table of interpolated values
      	common /mfunc/ table(40:60,0:50,0:90)  ! model function table
     	data kt1min, kt1max /40, 59/
c	--------------------------------------------------------------
c 	Adjust the relative azimuth into the range (0.,180.) degrees
c 	  and get interpolation coefficient q:
c
c	print *,'imodel',kpol
	chi 	   = azi - phi
        chi        = amod(chi,360.)
	if (chi .lt. 0.)   chi = chi  + 360.
      	if (chi .gt. 180.) chi = 360. - chi
     	ichi       = int(chi/2.)
	q          = chi/2. - ichi
	q1         = 1. - q
c	print *,'imodel',chi,ichi,q,q1
c	---------------------------------------------------------------
c	Get interpolation coefficients w.r.t. incidence angle:
c
        htht       = tht  !/2.		! cut tht in half
	kt1        = int(htht)		! first index
     	if (kt1 .le. kt1min) kt1 = kt1min
      	if (kt1 .ge. kt1max) kt1 = kt1max
      	kt2        = kt1 + 1		! second index
     	at2        = htht - kt1		! second coefficient
      	at1        = 1. - at2		! first coefficient
c	---------------------------------------------------------------
c	for each possible wind speed, examine nrcs
c
c	print *,'imodel',tht,kt1,kt2,at1,at2
	do 80 ku=0,50
c
c	Interpolate with respect to incidence angle:
c
	  do 40 i = 1,2
	    kchi = i + ichi - 1
	    if (kchi .gt. 90) kchi = 180 - kchi
	    mfun(i) =  at1*table(kt1,ku,kchi) +
     $		       at2*table(kt2,ku,kchi) !,kpol)
 40	  continue
c	---------------------------------------------------------------
c	Do linear interpolation of the working table to find nrcs as a
c	function of direction
c
	  anrcs = q1*mfun(1) + q*mfun(2) 
c
c	---------------------------------------------------------------
c	check tabulated nrcs against input nrcs and interpolate to get wind
c	speed
c
c	  print *,'imodel',ju,nrcs,alast,anrcs
	  if (ku.eq.1) then
			alast=anrcs
			goto 80
	  endif
	  if (ku.eq.2) then
		if (nrcs.lt.alast) then	! extrapolate below usable table
			u=(nrcs-alast)/(anrcs-alast)+1.
			if (u.le.0.5) u=0.5
			return
		endif
	  endif
	  if (ku.eq.50) then
		if (nrcs.gt.anrcs) then
			u=(nrcs-anrcs)/(anrcs-alast)+50.
			return
		endif
	  endif
	  if (nrcs.ge.alast.and.nrcs.le.anrcs) then
		u=(nrcs-alast)/(anrcs-alast)+ku-1.
		return
	  endif
	  alast=anrcs
c
80	continue
c
	return
	end
